package com.mortals.xhx.common.utils;

import com.alibaba.fastjson.JSON;
import com.mortals.xhx.common.code.FiletypeEnum;
import com.mortals.xhx.common.code.SourceEnum;
import com.mortals.xhx.module.matter.model.MatterDatumFileEntity;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;
import java.util.*;

@Slf4j
public class MatterDetailHtmlParseUtil {

    public static Document getDomByHtml(String url) {
        Document document = null;
        try {
            document = Jsoup.connect(url).get();
            return document;
            /*Jsoup.connect(url).get();
            html = Jsoup.connect(url).get().body().html();

            // html = HttpUtil.get(url);
            //System.out.println(html);
            HtmlCleaner hc = new HtmlCleaner();
            TagNode tn = hc.clean(html);


            Object[] rs = tn.evaluateXPath("//div");

            for (Integer i = 0; i < rs.length; i++) {
                TagNode n = (TagNode) rs[i];
                System.out.println(n.getText());
            }*/

            // System.out.println(tn.getText());
/*            CleanerProperties cleanerProperties = new CleanerProperties();

            cleanerProperties.setAdvancedXmlEscape(true);

            cleanerProperties.setOmitXmlDeclaration(true);
            cleanerProperties.setOmitDoctypeDeclaration(true);

            cleanerProperties.setTranslateSpecialEntities(true);
            cleanerProperties.setTransResCharsToNCR(true);
            cleanerProperties.setRecognizeUnicodeChars(true);

            cleanerProperties.setIgnoreQuestAndExclam(true);
            cleanerProperties.setUseEmptyElementTags(false);
            Document dom = new DomSerializer(cleanerProperties).createDOM(tn);*/
            /*XPath xPath = XPathFactory.newInstance().newXPath();

            String tklrExp = String.format("//div[@class=\"smltc9_bottom\"]//p");
            Object result = xPath.evaluate(tklrExp, dom, XPathConstants.NODESET);

            NodeList nodeList = (NodeList) result;

            for (Integer i = 0; i < nodeList.getLength(); i++) {
                System.out.println(nodeList.item(i).getTextContent());
                System.out.println("===============");
            }*/
            //div[@class='section10']//table[1]//tr[%d]//td
            //return dom;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * 解析事项基本信息
     *
     * @param dom
     * @return
     */
    public static Map<String, String> getbaseInfoMapByHtml(Document dom) {
        Map<String, String> params = new HashMap<>();
        String baseInfoExp = "//div[@class=\"section1\"]//table[1]//td";
        String baseInfoExp1 = "//div[@class=\"section2\"]/table[1]//td";
        String baseInfoExp2 = "//div[@class=\"section3\"]/table[1]//td";
        String baseInfoExp3 = "//div[@class=\"section4\"]/table//td";
        baseInfoExp += "|" + baseInfoExp1;
        baseInfoExp += "|" + baseInfoExp2;
        baseInfoExp += "|" + baseInfoExp3;
        try {
            Elements elements = dom.selectXpath(baseInfoExp);
            for (int i = 0; i < elements.size(); i++) {
                Element element = elements.get(i);
                if (element == null) {
                    continue;
                }
                if (i % 2 == 0) {
                    continue;
                }
                if (i > 0) {
                    Element prenode = elements.get(i - 1);
                    params.put(prenode.text().trim(), element.text().trim());
                }
            }
        } catch (Exception e) {
            log.error("基本信息xpath解析异常:", e);
        }
        return params;
    }

    /**
     * 申请材料表格解析
     *
     * @param dom
     * @return [{"baseinfo":{...},"blankList":[...],,"sampleList":[...]},...]
     */
    public static List<Map<String, Object>> getsqclInfoMapByHtml(Document dom) {
        List<Map<String, Object>> mapList = new ArrayList<>();
        String blankSampleExp = "//div[@id=\"zhezhao\"]//div[@class='zhezhao4']";
        String sampleExp = "//div[@id=\"zhezhao\"]//div[@class='zhezhao2']";
        String baseInfoExp = "//div[@id=\"zhezhao\"]//div[@class='zhezhao3']";
        try {
            Elements elements = dom.selectXpath(blankSampleExp);
            int rowNum = elements.size();

            for (int i = 1; i <= rowNum; i++) {
                HashMap<String, Object> map = new HashMap<>();
                List<MatterDatumFileEntity> datumFileEntities = new ArrayList<>();
                List<MatterDatumFileEntity> datumSampleFileEntities = new ArrayList<>();
                //查询空白样表数量
                String tempxPath = blankSampleExp + String.format("[%d]//table//tr[position()>1]//td", i);

                Elements evaluateList = dom.selectXpath(tempxPath);
                for (int j = 0; j < evaluateList.size(); j++) {
                    if (j % 2 == 0) {
                        continue;
                    }
                    Element node = evaluateList.get(j);
                    if (j > 0) {
                        Element prenode = evaluateList.get(j - 1);
                        MatterDatumFileEntity fileEntity = new MatterDatumFileEntity();
                        fileEntity.setCreateTime(new Date());
                        fileEntity.setCreateUser("system");
                        fileEntity.setSource(SourceEnum.政务网.getValue());
                        fileEntity.setFiletype(FiletypeEnum.空白表格.getValue());
                        fileEntity.setFileName(prenode.text().trim());
                        fileEntity.setFileUrl(node.firstChild().attr("href").trim());
                        datumFileEntities.add(fileEntity);
                    }
                }
                map.put("blankList", datumFileEntities);
                //查询样表
                String tempxPath1 = sampleExp + String.format("[%d]//table//tr[position()>1]//td", i);
                Elements sampleList = dom.selectXpath(tempxPath1);

                for (int j = 0; j < sampleList.size(); j++) {
                    if (j % 2 == 0) {
                        continue;
                    }
                    Element node = sampleList.get(j);
                    if (j > 0) {
                        Element prenode = sampleList.get(j - 1);
                        MatterDatumFileEntity fileEntity = new MatterDatumFileEntity();
                        fileEntity.setCreateTime(new Date());
                        fileEntity.setCreateUser("system");
                        fileEntity.setSource(SourceEnum.政务网.getValue());
                        fileEntity.setFiletype(FiletypeEnum.示例样表.getValue());
                        fileEntity.setFileName(prenode.text().trim());
                        fileEntity.setFileUrl(node.firstChild().attr("href").trim());
                        datumSampleFileEntities.add(fileEntity);
                    }
                    map.put("sampleList", datumSampleFileEntities);
                }


                //查询基本信息
                String tempxPath2 = baseInfoExp + String.format("[%d]//table//tr//td", i);
                Elements baseinfoList = dom.selectXpath(tempxPath2);
                HashMap<String, String> baseInfoMap = new HashMap<>();
                for (int j = 0; j < baseinfoList.size(); j++) {
                    if (j % 2 == 0) {
                        continue;
                    }
                    Element node = baseinfoList.get(j);
                    if (j > 0) {
                        Element prenode = baseinfoList.get(j - 1);
                        baseInfoMap.put(prenode.text().trim(), node.text().trim());
                    }
                }
                map.put("baseinfo", baseInfoMap);
                mapList.add(map);
            }
        } catch (Exception e) {
            log.error("申请材料表格解析xpath解析异常:", e);
        }
        return mapList;
    }


    /**
     * 受理条件
     *
     * @param dom
     * @return {"sltj":"..."}
     */
    public static Map<String, String> getSltjMapByHtml(Document dom) {
        Map<String, String> resultMap = new HashMap<>();
        String baseInfoExp = "//div[@class='section6']//p";
        try {
            Elements elements = dom.selectXpath(baseInfoExp);
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < elements.size(); i++) {
                sb.append(elements.get(i).text().trim());
            }
            resultMap.put("sltj", sb.toString());
        } catch (Exception e) {
            log.error("受理条件xpath解析异常:", e);
        }
        return resultMap;
    }

    /**
     * 办理流程
     *
     * @param dom
     * @return [{key:vlaue},{key:value}....]
     */
    public static List<Map<String, Object>> getbllcMapByHtml(Document dom) {
        List<Map<String, Object>> resultListMap = new ArrayList<>();
        String baseInfoExp = "//div[@class='section7']//table[1]//tr[1]//td";
        String baseInfoExp1 = "//div[@class='section7']//table[1]//tr";
        XPath xPath = XPathFactory.newInstance().newXPath();
        Object result;
        int rowNum = 0;
        try {
            Elements elements = dom.selectXpath(baseInfoExp1);
            rowNum = elements.size();
            Elements nodeList = dom.selectXpath(baseInfoExp);
            for (int j = 1; j <= rowNum; j++) {
                Map<String, Object> map = new HashMap<>();
                String baseInfoTempExp = String.format("//div[@class='section7']//table[1]//tr[%d]//td", j + 1);
                Elements evaluateList = dom.selectXpath(baseInfoTempExp);
                for (int k = 0; k < evaluateList.size(); k++) {
                    map.put(nodeList.get(k).text(), evaluateList.get(k).text().trim());
                    map.put("sort", j);
                }
                resultListMap.add(map);
            }
            /*
            result = xPath.evaluate(baseInfoExp1, dom, XPathConstants.NODESET);
            if (result instanceof NodeList) {
                NodeList nodeList = (NodeList) result;
                rowNum = nodeList.getLength();
            }
            result = xPath.evaluate(baseInfoExp, dom, XPathConstants.NODESET);
            if (result instanceof NodeList) {
                NodeList nodeList = (NodeList) result;
                // int num = nodeList.getLength();
                for (int j = 1; j <= rowNum; j++) {
                    Map<String, Object> map = new HashMap<>();
                    String baseInfoTempExp = String.format("//div[@class='section7']//table[1]//tr[%d]//td", j + 1);
                    Object evaluate = xPath.evaluate(baseInfoTempExp, dom, XPathConstants.NODESET);
                    if (evaluate instanceof NodeList) {
                        NodeList evaluateList = (NodeList) evaluate;
                        for (int k = 0; k < evaluateList.getLength(); k++) {
                            map.put(nodeList.item(k).getTextContent(), evaluateList.item(k).getTextContent().trim());
                            map.put("sort", j);
                        }
                    }
                    resultListMap.add(map);
                }
            }*/
        } catch (Exception e) {
            log.error("办理流程xpath解析异常:", e);
        }
        return resultListMap;
    }

    /**
     * 收费标准
     *
     * @param dom
     * @return {"sfbz":"..."}
     */
    public static Map<String, String> getSfbzMapByHtml(Document dom) {
        Map<String, String> resultMap = new HashMap<>();
        String baseInfoExp = "//div[@class='section8']//p";
        try {
            Elements elements = dom.selectXpath(baseInfoExp);
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < elements.size(); i++) {
                sb.append(elements.get(i).text());
            }
            resultMap.put("sfbz", sb.toString());
           /* result = xPath.evaluate(baseInfoExp, dom, XPathConstants.NODESET);
            if (result instanceof NodeList) {
                NodeList nodeList = (NodeList) result;
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < nodeList.getLength(); i++) {
                    sb.append(nodeList.item(i).getTextContent());
                }
                resultMap.put("sfbz", sb.toString());
            }*/
        } catch (Exception e) {
            log.error("收费标准xpath解析异常:", e);
        }
        return resultMap;
    }


    /**
     * 设定依据
     *
     * @param dom
     * @return [{key:vlaue},{key:value}....]
     */
    public static List<Map<String, Object>> getSdyjMapByHtml(Document dom) {
        List<Map<String, Object>> resultListMap = new ArrayList<>();
        String baseInfoExp = "//div[@class='section9']//table[1]//tr";
        String baseInfoExp1 = "//div[@class='section9']//table[1]//tr[1]//td";
        int num = 0;
        try {
            Elements elements = dom.selectXpath(baseInfoExp);
            num = elements.size();
            Elements nodeList = dom.selectXpath(baseInfoExp1);
            for (int j = 1; j < num; j++) {
                Map<String, Object> map = new HashMap<>();
                String baseInfoTempExp = String.format("//div[@class='section9']//table[1]//tr[%d]//td", j + 1);
                Elements evaluateList = dom.selectXpath(baseInfoTempExp);

                for (int k = 1; k < evaluateList.size(); k++) {
                    map.put(nodeList.get(k - 1).text().trim(), evaluateList.get(k).text().trim());
                    if (nodeList.get(k - 1).text().trim().equalsIgnoreCase("条款内容")) {
                        //查找对应内容
                        String tklrExp = String.format("//div[@class=\"smltc9_bottom\"]//p");
                        Elements tklrList = dom.selectXpath(tklrExp);
                        map.put(nodeList.get(k - 1).text().trim(), tklrList.get(j - 1).text().trim());
                    }
                }
                map.put("sort", j);
                resultListMap.add(map);
            }


/*
            result = xPath.evaluate(baseInfoExp, dom, XPathConstants.NODESET);

            NodeList nodeList = (NodeList) result;
            num = nodeList.getLength();
            result = xPath.evaluate(baseInfoExp1, dom, XPathConstants.NODESET);
            nodeList = (NodeList) result;
            for (int j = 1; j < num; j++) {
                Map<String, Object> map = new HashMap<>();
                String baseInfoTempExp = String.format("//div[@class='section9']//table[1]//tr[%d]//td", j + 1);
                Object evaluate = xPath.evaluate(baseInfoTempExp, dom, XPathConstants.NODESET);

                NodeList evaluateList = (NodeList) evaluate;
                for (int k = 1; k < evaluateList.getLength(); k++) {
                    map.put(nodeList.item(k - 1).getTextContent(), evaluateList.item(k).getTextContent().trim());
                    if (nodeList.item(k - 1).getTextContent().trim().equalsIgnoreCase("条款内容")) {
                        //查找对应内容
                        String tklrExp = String.format("//div[@class=\"smltc9_bottom\"]//p");
                        Object tklr = xPath.evaluate(tklrExp, dom, XPathConstants.NODESET);
                        NodeList tklrList = (NodeList) tklr;
                        map.put(nodeList.item(k - 1).getTextContent(), tklrList.item(j - 1).getTextContent().trim());
                    }
                }
                map.put("sort", j);
                resultListMap.add(map);
            }*/

        } catch (Exception e) {
            log.error("设定依据xpath解析异常:", e);
        }
        return resultListMap;
    }


    /**
     * 中介服务
     *
     * @param dom
     * @return [{key:vlaue},{key:value}....]
     */
    public static Map<String, String> getZjfwMapByHtml(Document dom) {
        Map<String, String> map = new HashMap<>();
        String baseInfoExp = "//div[@class='section10']//table[1]//tr";
        int rownum = 0;
        try {
            Elements elements = dom.selectXpath(baseInfoExp);
            rownum = elements.size();
            for (int j = 1; j <= rownum; j++) {
                String baseInfoTempExp = String.format("//div[@class='section10']//table[1]//tr[%d]//td", j);
                Elements evaluateList = dom.selectXpath(baseInfoTempExp);
                if (evaluateList.size() > 1) {
                    map.put(evaluateList.get(evaluateList.size() - 2).text().trim(), evaluateList.get(evaluateList.size() - 1).text().trim());
                }
            }
        } catch (Exception e) {
            log.error("中介服务xpath解析异常:", e);
        }
        return map;
    }

    /**
     * 常见问题
     *
     * @param dom
     * @return [{key:vlaue},{key:value}....]
     */
    public static List<Map<String, Object>> getCjwtMapByHtml(Document dom) {
        List<Map<String, Object>> resultListMap = new ArrayList<>();
        String baseInfoExp = "//div[@class='section11']//table[1]//tr";
        int num = 0;
        try {
            Elements elements = dom.selectXpath(baseInfoExp);
            num = elements.size();
            for (int j = 1; j <= num; j++) {
                Map<String, Object> map = new HashMap<>();
                String baseInfoTempExp = String.format("//div[@class='section11']//table[1]//tr[%d]//td[2]", j);
                Elements evaluateList = dom.selectXpath(baseInfoTempExp);
                for (int k = 0; k < evaluateList.size(); k++) {
                    map.put(evaluateList.get(k).firstElementChild().text(), evaluateList.get(k).lastElementChild().text().trim());
                }
                //map.put("sort", j);
                resultListMap.add(map);
            }
        } catch (Exception e) {
            log.error("常用问题xpath解析异常:", e);
        }
        return resultListMap;
    }

    public static void main(String[] args) {
        // String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=510110006007&itemCode=512B0066400008-510110006007-000-54510116ME12555679-1-00&taskType=20&deptCode=1703381";
        //String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=511102000000&itemCode=F-000088-001-511102000000-000-11511002008554411P-1-00&taskType=7&deptCode=11511002008554411P";
        //String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=511102000000&itemCode=511A0116400001-511102000000-000-11511000008554251k-1-00&taskType=1&deptCode=1151124000008554251k_28064";
        // String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=510110307000&itemCode=511E99406004-510110307000-000-11510110009212261X-1-00&taskType=9&deptCode=1703461";
        //String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=511102000000&itemCode=511A0099100005-511102000000-000-11511002735871990X-1-00&taskType=1&deptCode=11511002735871990X";
        //String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=513426000000&itemCode=511F3000300009-513426000000-000-11513426MB1541028A-1-00&taskType=7&deptCode=009075316";

        String url = "http://www.sczwfw.gov.cn/jiq/front/transition/ywTransToDetail?areaCode=511500000000&itemCode=511A0152600000-511500000000-000-511501-7-1-00&taskType=1&deptCode=511501-7";

        Document dom = MatterDetailHtmlParseUtil.getDomByHtml(url);
        Map<String, String> baseInfoMap = MatterDetailHtmlParseUtil.getbaseInfoMapByHtml(dom);
        System.out.println(JSON.toJSONString(baseInfoMap));
        baseInfoMap.entrySet().stream().forEach(item -> {
            System.out.println(item.getKey() + "=" + item.getValue());
        });

        List<Map<String, Object>> mapList = MatterDetailHtmlParseUtil.getsqclInfoMapByHtml(dom);
        System.out.println(JSON.toJSONString(mapList));

        Map<String, String> sltjMapByHtml = MatterDetailHtmlParseUtil.getSltjMapByHtml(dom);
        System.out.println("==============受理条件==============");
        System.out.println(JSON.toJSONString(sltjMapByHtml));

        System.out.println("==============办理流程==============");
        List<Map<String, Object>> bllcListMap = MatterDetailHtmlParseUtil.getbllcMapByHtml(dom);
        System.out.println(JSON.toJSONString(bllcListMap));

        System.out.println("==============收费标准==============");
        Map<String, String> sfbzMapByHtml = MatterDetailHtmlParseUtil.getSfbzMapByHtml(dom);
        System.out.println(JSON.toJSONString(sfbzMapByHtml));

        System.out.println("==============设定依据==============");
        List<Map<String, Object>> sdyjMapByHtml = MatterDetailHtmlParseUtil.getSdyjMapByHtml(dom);
        System.out.println(JSON.toJSONString(sdyjMapByHtml));
        System.out.println("==============中介服务==============");
        Map<String, String> zjfwMapByHtml = MatterDetailHtmlParseUtil.getZjfwMapByHtml(dom);
        System.out.println(JSON.toJSONString(zjfwMapByHtml));

        System.out.println("==============常见问题==============");
        List<Map<String, Object>> cjwtMapByHtml = MatterDetailHtmlParseUtil.getCjwtMapByHtml(dom);
        System.out.println(JSON.toJSONString(cjwtMapByHtml));


    }
}
